from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory, String, Int, File

Bamtobw_Pl_V0_1_0 = CommandToolBuilder(tool="bamToBw.pl", base_command=["bamToBw.pl"], inputs=[ToolInput(tag="in_bamcram_file_processed", input_type=Boolean(optional=True), prefix="-bam", doc=InputDocumentation(doc="BAM/CRAM file to be processed.")), ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="-outdir", doc=InputDocumentation(doc="Folder to output result to.")), ToolInput(tag="in_reference", input_type=Boolean(optional=True), prefix="-reference", doc=InputDocumentation(doc="Path to genome.fa.\n- Actually using fa.fai but for convention just provide '.fa' file")), ToolInput(tag="in_number_threads_use", input_type=Boolean(optional=True), prefix="-threads", doc=InputDocumentation(doc="Number of threads to use. [1]")), ToolInput(tag="in_ignore_reads_filter", input_type=Boolean(optional=True), prefix="-filter", doc=InputDocumentation(doc="Ignore reads with the filter flags [int]")), ToolInput(tag="in_only_process_step", input_type=Boolean(optional=True), prefix="-process", doc=InputDocumentation(doc="Only process this step then exit, optionally set -index\nbamToBw - Per chromosome BigWigs\ngenerateBw - Generates merged BigWig")), ToolInput(tag="in_index", input_type=Boolean(optional=True), prefix="-index", doc=InputDocumentation(doc="Optionally restrict '-p' to single job\nbwamem - 1..<lane_count>")), ToolInput(tag="in_parallel_step_report", input_type=Boolean(optional=True), prefix="-jobs", doc=InputDocumentation(doc="For a parallel step report the number of jobs required")), ToolInput(tag="in_man", input_type=Boolean(optional=True), prefix="-man", doc=InputDocumentation(doc="Full documentation.")), ToolInput(tag="in_var_9", input_type=Boolean(optional=True), prefix="-help", doc=InputDocumentation(doc="")), ToolInput(tag="in_advanced", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_11", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_basic", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_brief", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_folder", input_type=Directory(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_for", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_full", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_ignore", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_18", input_type=Int(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_only", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_optional", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_optionally", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_other", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_path", input_type=File(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_required", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_run", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_targeted", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_bwa_mem", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_generate_bw", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_a", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_30", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_of", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_parameters", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_33", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_processing", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_reads", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_restrict", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_to", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_usage", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_genome_dot_fa_dot", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_output", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_parallel", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_this", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_43", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_with", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_result", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_step", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_the", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_48", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_report", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_then", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_use_dot", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_exit", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_flags", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_54", input_type=Int(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_55", input_type=String(), position=8, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Folder to output result to."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Bamtobw_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

